using UnityEngine;
using System.Collections;
using PlayerCoreEngine;
using LevelInterface;
using NewLevelStates;

public class TurningScript : MonoBehaviour {
	
	
	private float m_fRotateSpeed = 100.0f;
	public LevelStates levestate;
	public GameObject player;
	public GameObject holeObject;
	public GameObject holeBackObject;
	
	//public GameObject playerPrefeb;
	
	public NewLevelAbstract m_CurrentState{get;set;} // newcode
	// Use this for initialization
	void Awake()
	{
		levestate = new LevelStates();
		
		m_CurrentState = new FaceUpState(this);//newcode
	}
	
	void Start () {
	
		
		levestate.CurrentLevel = LevelStates.eLevelStates.Stop;
	}
	
	// Update is called once per frame
	void Update () {
		
	   if (States.s_bTouchedHole)
		{
			levestate.CurrentLevel = LevelStates.eLevelStates.TurningDown;
	//		Debug.Log ("Turning");
		}
		
		if (States.s_bTouchedBackHole)
		{
			levestate.CurrentLevel = LevelStates.eLevelStates.TurningUp;	
		}
		
		if (gameObject.transform.rotation.z > 0.9f
			&& States.s_bTouchedBackHole == false)
		{
			levestate.CurrentLevel = LevelStates.eLevelStates.FacingDown;	
		}
		else if (gameObject.transform.rotation.z < 0.2 
			&& States.s_bTouchedBackHole == true)
		{
			levestate.CurrentLevel = LevelStates.eLevelStates.FacingUp;		
		}
		
		CheckStates();
		
//	Debug.Log (gameObject.transform.rotation.z);
	}
	
	
	void CheckStates()
	{
		if (levestate.CurrentLevel == LevelStates.eLevelStates.TurningDown)
		{
			//player go wieht holes
		  	player.transform.parent = holeObject.transform;
			player.transform.Translate(Vector3.up * -9.0f * Time.deltaTime);
				//player.transform.position = new Vector3 (holeObject.GetComponent<HoleSpcript>().m_vHolePosition.x,
				//holeObject.GetComponent<HoleSpcript>().m_vHolePosition.y + 10.0f,holeObject.GetComponent<HoleSpcript>().m_vHolePosition.z);
			turningToBackSide();	
		}		
		else if (levestate.CurrentLevel == LevelStates.eLevelStates.FacingDown)
		{
			gameObject.transform.rotation = new Quaternion (0,0,180,0);	
			States.s_bTouchedHole = false;
			//set player back to normal
			player.transform.parent = null;
			player.transform.rotation = new Quaternion (0,0,0,0);
			
			levestate.CurrentLevel = LevelStates.eLevelStates.FacingDown;	
		}
		else if (levestate.CurrentLevel == LevelStates.eLevelStates.TurningUp)
		{
			player.transform.parent = holeBackObject.transform;
			//player.transform.Translate(Vector3.up * -6.0f * Time.deltaTime);
			player.transform.position = new Vector3 (holeBackObject.GetComponent<BackHoleScript>().m_vBackpoinPosition.x,
				holeBackObject.GetComponent<BackHoleScript>().m_vBackpoinPosition.y,holeBackObject.GetComponent<BackHoleScript>().m_vBackpoinPosition.z);
			turningToFrontSide();	
		}
		else if (levestate.CurrentLevel == LevelStates.eLevelStates.FacingUp)
		{
			gameObject.transform.rotation = new Quaternion (0,0,0,0);	
			States.s_bTouchedBackHole = false;
			////set player back to normal
			player.transform.parent = null;
			player.transform.rotation = new Quaternion (0,0,0,0);
			//player.transform.position = new Vector3 (holeBackObject.transform.position.x, player.transform.position.y, holeBackObject.transform.position.z);
			//levestate.CurrentLevel = LevelStates.eLevelStates.FacingDown;	
		}
		
		
			
	}
	
	public void turningToBackSide()
	{
		gameObject.transform.Rotate (Vector3.forward * m_fRotateSpeed * Time.deltaTime);		
	}
	
	void turningToFrontSide()
	{
			
		gameObject.transform.Rotate (Vector3.forward * -m_fRotateSpeed * Time.deltaTime);
	}
	
	
}
